"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Config_1 = require("../Config");
const DotDocGenerator_1 = require("./dot/DotDocGenerator");
const TextDocGenerator_1 = require("./text/TextDocGenerator");
var DocGeneratorFactory;
(function (DocGeneratorFactory) {
    function create(config, outputter) {
        switch (config.format) {
            case Config_1.DocFormat.Dot:
                return new DotDocGenerator_1.DotDocGenerator(config, outputter);
            case Config_1.DocFormat.Text:
                return new TextDocGenerator_1.TextDocGenerator(config, outputter);
            default:
                throw new Error(`unhandled format '${config.format}'`);
        }
    }
    DocGeneratorFactory.create = create;
})(DocGeneratorFactory = exports.DocGeneratorFactory || (exports.DocGeneratorFactory = {}));
//# sourceMappingURL=DocGeneratorFactory.js.map