"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Edge {
    constructor(origin, destination) {
        this.origin = origin;
        this.destination = destination;
    }
    static create(origin, destination) {
        const edge = new Edge(origin, destination);
        origin.outgoingEdges.push(edge);
        destination.incomingEdges.push(edge);
    }
    get id() {
        return `${this.origin.id}->${this.destination.id}`;
    }
    remove() {
        this.origin.removeOutgoingEdge(this);
        this.destination.removeIncomingEdge(this);
    }
}
exports.Edge = Edge;
//# sourceMappingURL=Edge.js.map