"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DocGeneratorFactory_1 = require("./generators/DocGeneratorFactory");
const OutputterFactory_1 = require("./outputters/OutputterFactory");
const ArgsParser_1 = require("./utils/ArgsParser");
const TslintConfigLoader_1 = require("./utils/TslintConfigLoader");
const UsageText_1 = require("./utils/UsageText");
function main() {
    const config = ArgsParser_1.ArgsParser.getConfigFromArgs();
    if (!config) {
        UsageText_1.UsageText.showUsage();
        return;
    }
    const outputter = OutputterFactory_1.OutputterFactory.create(config);
    const generator = DocGeneratorFactory_1.DocGeneratorFactory.create(config, outputter);
    TslintConfigLoader_1.TslintConfigLoader.loadTslintConfig(config).then(packageConfig => {
        generator.generateDoc(packageConfig);
    });
}
main();
//# sourceMappingURL=index.js.map