"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const OutputterBase_1 = require("./OutputterBase");
const NEW_LINE = "\n";
class FileOutputter extends OutputterBase_1.OutputterBase {
    constructor(outpath) {
        super();
        this.outpath = outpath;
        this.firstWrite = true;
    }
    /**
     * Write to file as soon as possible (in case debugging)
     *
     * note: node 'fs.sync' is not really sync writing
     * ref: https://www.daveeddy.com/2013/03/26/synchronous-file-io-in-nodejs/
     * but it simplifies the API here
     */
    writeLine(text) {
        const line = text + NEW_LINE;
        if (fs.existsSync(this.outpath) && !this.firstWrite) {
            fs.appendFileSync(this.outpath, line);
        }
        else {
            fs.writeFileSync(this.outpath, line, "utf8");
        }
        this.firstWrite = false;
    }
}
exports.FileOutputter = FileOutputter;
//# sourceMappingURL=FileOutputter.js.map