"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const SPACES_PER_TAB = 2;
class OutputterBase {
    constructor() {
        this.indent = 0;
    }
    decreaseIndent() {
        this.indent--;
        if (this.indent < 0) {
            throw new Error("indent would be negative!");
        }
    }
    increaseIndent() {
        this.indent++;
    }
    outputLine(text) {
        const indentText = " ".repeat(this.indent * SPACES_PER_TAB);
        this.writeLine(`${indentText}${text}`);
    }
    outputLines(lines) {
        lines.forEach(line => this.outputLine(line));
    }
}
exports.OutputterBase = OutputterBase;
//# sourceMappingURL=OutputterBase.js.map